Bullet = class{name = 'Bullet', function(self, pos, vel, lifetime, group, damage)
	local w,h = IMAGES['bullet.png']:getWidth(), IMAGES['bullet.png']:getHeight()
	self.ox = w/2
	self.oy = h/2

	self.shape = HC.addPoint(pos.x, pos.y)
	if group then
		HC.addToGroup(group, self.shape)
	end

	self.shape.class = Bullet
	self.shape.self = self
	self.vel = vel
	self.damage = damage or .1

	Timer.add(lifetime, function() self:destroy() end)

	audio.play(SOUNDS['shot.ogg'], 1, false)

	-- register oneself
	ENTITIES[self] = self
end}

function Bullet:draw()
	local x,y = self.shape:center()
	love.graphics.setColor(255,255,255)
	love.graphics.draw(IMAGES['bullet.png'], x,y, 0,1,1, self.ox,self.oy)
end

function Bullet:update(dt)
	self.shape:move( (self.vel * dt):unpack() )
end

function Bullet:destroy()
	HC.remove(self.shape)
	ENTITIES[self] = nil
end

package.loaded[...] = Bullet
