require 'entities.ship'

Player = class{name = 'Player', inherits = Ship, function(self, x,y)
	Ship.construct(self, x,y, 'player.png', .2, 30, 2, .13, .25)
	self.cash = 0
	self.is_player = true
end}

function Player:update(dt)
	self.vel = vector(0,0)
	if love.keyboard.isDown('up') then
		self.vel.y = -1
	elseif love.keyboard.isDown('down') then
		self.vel.y = .2
	end

	if love.keyboard.isDown('left') then
		self.shape:rotate(-dt * self.agility)
	elseif love.keyboard.isDown('right') then
		self.shape:rotate(dt * self.agility)
	end
	self.vel:rotate_inplace( self.shape:rotation() )

	if love.keyboard.isDown(' ') then
		self:shoot(Player)
	end

	self:move(dt)
end

function Player.collision_handler.ammo(self, item)
	if not self.is_player then return end
	HC.remove(item.shape)
	ENTITIES[item] = nil
	self.gun_delay = math.max(self.gun_delay - .01, .15)
end

function Player.collision_handler.cash(self, item)
	if not self.is_player then return end
	HC.remove(item.shape)
	ENTITIES[item] = nil
	self.cash = self.cash + math.random(1,20) * 10
end

function Player.collision_handler.health(self, item)
	if not self.is_player then return end
	HC.remove(item.shape)
	ENTITIES[item] = nil
	self.life = math.min(self.life + .1, 1)
end

function Player.collision_handler.scope(self, item)
	if not self.is_player then return end
	HC.remove(item.shape)
	ENTITIES[item] = nil
	self.accuracy = math.max(0.01, self.accuracy - .02)
end

function Player.collision_handler.speed(self, item)
	if not self.is_player then return end
	HC.remove(item.shape)
	ENTITIES[item] = nil
	self.speed = self.speed + 2
	self.agility = self.agility + .1
end

package.loaded[...] = Player
