local state = GS.new()
package.loaded[...] = state

-- ----------------------- --
--     STATE FUNCTIONS     --
-- ----------------------- --
function state:init()
	self.quad_bg = love.graphics.newQuad(0,0, SCR_WIDTH * 2, SCR_HEIGHT * 2, 512,512)
end

local texts = {}
texts.winner = [[You've done it! You killed every one of them!

After the last wave of endorphines left your system, you cannot but wonder what you will do next. There is no one left to challange you.

You now have absolute power.
Time to make those villagers feel that power...]]

texts.loser = [[You tried, but you failed. Miserably.

You met the same fate as every other soldier of fortune before you. The villagers curse your name as you brought the clan's wrath upon them.

But it won't be long until you are forgotten. Life will go on.

Except for you.]]

function state:enter(_,text)
	self.text = texts[text]
	self.bg_pos = 0
	self.update_bg_pos = Timer.Oscillator(40, function(f)
		self.bg_pos = -f * SCR_HEIGHT
	end)

	self.scroll_pos = SCR_HEIGHT
	self.update_scroll_pos = function() end
	Timer.add(10, function()
		self.fadeIn = Timer.Interpolator(3, function(f)
			self.press_start_alpha = f * 255
		end)
	end)

	self.black_alpha = 0
	self.fadeIn = Timer.Interpolator(1, function(f)
		self.black_alpha = (1 - f) * 255
	end)

	self.press_start_alpha = 0

	audio.stream('pharmacokinetik.mp3', .6)
end

function state:draw()
	love.graphics.setColor(255,255,255)
	love.graphics.drawq(IMAGES['water02.jpg'], self.quad_bg, 0, self.bg_pos)

	love.graphics.setFont(FONTS[30])
	love.graphics.printf(self.text, 25, 150, SCR_WIDTH - 50, 'center')

	love.graphics.setColor(255,255,255, self.press_start_alpha)
	love.graphics.printf('PRESS START', 0, SCR_HEIGHT - 60, SCR_WIDTH, 'center')

	love.graphics.setColor(0,0,0, self.black_alpha)
	love.graphics.rectangle('fill', 0,0, SCR_WIDTH, SCR_HEIGHT)
end

function state:update(dt)
	self.fadeIn(dt)
	self.update_bg_pos(dt)
end

function state:keyreleased(key)
	if key == 'return' then
		self.fadeIn = Timer.Interpolator(1, function(f)
			self.black_alpha = f * 255
		end)
		Timer.add(1, function() GS.switch(states.menu) end)
	end
end

return state
